import _extends from "@babel/runtime/helpers/extends";
import _Empty from "antd/es/empty";
import _message from "antd/es/message";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import React, { forwardRef, useEffect, useImperativeHandle, useState } from "react";
import FileSaver from "file-saver";
import JSZip from "jszip";
// import { CodeGenPreview } from "../code-gen-preview/index";
import { SourcesView } from "../sources-view/index";
import "./index.less";
export var CodeGenResult = /*#__PURE__*/forwardRef(function CodeGenResult(_ref, ref) {
  var result = _ref.result,
    schema = _ref.schema;
  var _useState = useState({
      expandedKeys: ["sources", "preview"]
    }),
    paneState = _useState[0],
    setPaneState = _useState[1];
  var _useState2 = useState(null),
    gravityCode = _useState2[0],
    setGravityCode = _useState2[1];
  var _useState3 = useState(0),
    refresh = _useState3[0],
    setRefresh = _useState3[1];
  useEffect(function () {
    console.log("--result, schema", result, schema);
    setGravityCode(convertCodeGenResult(result, schema));
  }, [result]);
  var codeZip = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      var zip;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            zip = new JSZip();
            Object.values((gravityCode === null || gravityCode === void 0 ? void 0 : gravityCode.modules) || {}).forEach(function (file) {
              zip.file(file.fpath.replace(/^\/+/, ""), file.code);
            });
            _context.next = 4;
            return zip.generateAsync({
              type: "blob"
            });
          case 4:
            return _context.abrupt("return", _context.sent);
          case 5:
          case "end":
            return _context.stop();
        }
      }, _callee);
    }));
    return function codeZip() {
      return _ref2.apply(this, arguments);
    };
  }();
  useImperativeHandle(ref, function () {
    return {
      codeZip: codeZip
    };
  });
  if (!result) {
    return null;
  }
  var handleDownloadSources = /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function _callee2(e) {
      var content;
      return _regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            _context2.prev = 0;
            e.preventDefault();
            e.stopPropagation();
            _context2.next = 5;
            return codeZip();
          case 5:
            content = _context2.sent;
            FileSaver.saveAs(content, "gant-lowcode-generated-sources.zip");
            _context2.next = 13;
            break;
          case 9:
            _context2.prev = 9;
            _context2.t0 = _context2["catch"](0);
            console.log("failed to download sources: ", _context2.t0);
            _message.error("下载失败！");
          case 13:
          case "end":
            return _context2.stop();
        }
      }, _callee2, null, [[0, 9]]);
    }));
    return function handleDownloadSources(_x) {
      return _ref3.apply(this, arguments);
    };
  }();
  console.log("--gravityCode", gravityCode);

  // const items: TabsProps["items"] = [
  //   {
  //     key: "sources",
  //     label: (
  //       <span>
  //         出码生成的源代码{" "}
  //         <a href="javascript:void(0)" onClick={handleDownloadSources}>
  //           导出/下载 zip 包
  //         </a>
  //       </span>
  //     ),
  //     children: gravityCode != null && (
  //       <SourcesView code={gravityCode} onCodeChange={setGravityCode} />
  //     ),
  //   },
  //   {
  //     key: "preview",
  //     label: (
  //       <span>
  //         在线预览{" "}
  //         <a
  //           href="#refresh"
  //           onClick={(e) => {
  //             e.preventDefault();
  //             e.stopPropagation();
  //             setRefresh(Date.now());
  //           }}
  //         >
  //           刷新
  //         </a>
  //       </span>
  //     ),
  //     children: (
  //       <div
  //         className="code-gen-result-gravity-demo"
  //         style={{ height: "100%" }}
  //       >
  //         <CodeGenPreview
  //           code={gravityCode}
  //           height={"100%"}
  //           refresh={refresh}
  //         />
  //       </div>
  //     ),
  //   },
  // ];

  // return <Tabs className="code-gen-tabs" items={items} />;

  if (!gravityCode) return /*#__PURE__*/React.createElement(_Empty, null);
  return /*#__PURE__*/React.createElement("div", {
    className: "code-gen-source-view"
  }, /*#__PURE__*/React.createElement(SourcesView, {
    code: gravityCode,
    onCodeChange: setGravityCode
  }));
});
function convertCodeGenResult(result, schema) {
  var schemaFiles = {
    "/.project-schema.json": {
      fpath: "/.project-schema.json",
      code: JSON.stringify(schema, null, 2) + "\n"
    }
  };
  if (!result || !Array.isArray(result) || !result.length) {
    return {
      type: "demo",
      modules: schemaFiles
    };
  }
  var code = {
    type: "demo",
    modules: result.reduce(function (acc, file) {
      var _extends2;
      return _extends({}, acc, (_extends2 = {}, _extends2["/" + file.pathName] = {
        fpath: "/" + file.pathName,
        code: file.content,
        entry: undefined,
        packagejson: ["package.json"].includes(file.pathName) ? 1 : undefined
      }, _extends2));
    }, {})
  };
  var foundEntry = false;

  // 设置入口文件
  ["index.js", "index.ts", "index.tsx", "app.js", "app.ts", "app.tsx"].forEach(function (fileName) {
    if (!foundEntry) {
      var filePath = "/src/" + fileName;
      if (code.modules[filePath]) {
        foundEntry = true;
        if (fileName === "index.js") {
          code.modules[filePath].entry = 1;
        } else {
          code.modules["/src/index.js"] = {
            fpath: "/src/index.js",
            entry: 1,
            code: "import \"./" + fileName.replace(/\.\w+$/, "") + "\""
          };
        }
      }
    }
  });
  if (!foundEntry) {
    console.warn("Failed to find entry file for demo.");
  }

  // 补充 schema 文件
  // Object.assign(code.modules, schemaFiles);

  return code;
}