"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.CodeGenActionBtn = CodeGenActionBtn;
exports.fixSchema = fixSchema;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _drawer = _interopRequireDefault(require("antd/lib/drawer"));
var _space = _interopRequireDefault(require("antd/lib/space"));
var _button = _interopRequireDefault(require("antd/lib/button"));
var _spin = _interopRequireDefault(require("antd/lib/spin"));
var _alert = _interopRequireDefault(require("antd/lib/alert"));
var _message2 = _interopRequireDefault(require("antd/lib/message"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _react = require("react");
var _standaloneLoader = require("@gant-lowcode/code-generator/standalone-loader");
var _lowcodeTypes = require("@gant-lowcode/lowcode-types");
var _coerce = _interopRequireDefault(require("semver/functions/coerce.js"));
var _compare = _interopRequireDefault(require("semver/functions/compare.js"));
var _index = require("../code-gen-result/index");
require("./index.less");
var _icons = require("@ant-design/icons");
var _fileSaver = _interopRequireDefault(require("file-saver"));
var _ahooks = require("ahooks");
function CodeGenActionBtn(_ref) {
  var ctx = _ref.ctx;
  var _useState = (0, _react.useState)({
      open: false,
      hasError: false,
      error: null,
      loading: false,
      result: null,
      schema: null,
      originalSchema: null
    }),
    state = _useState[0],
    setState = _useState[1];
  var codeGenResultRef = (0, _react.useRef)(null);
  var handleClick = /*#__PURE__*/function () {
    var _ref2 = (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee() {
      var getProjectSchema, originalSchema, schema, result;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            // 打开基于 Gravity 的编辑器/出码预览器
            setState(function (prev) {
              return (0, _extends2["default"])({}, prev, {
                loading: true,
                open: true,
                hasError: false
              });
            });
            console.log("--ctx", ctx);
            getProjectSchema = ctx.config.get("getProjectSchema");
            if (!getProjectSchema) {
              _context.next = 10;
              break;
            }
            _context.next = 7;
            return getProjectSchema();
          case 7:
            originalSchema = _context.sent;
            _context.next = 13;
            break;
          case 10:
            _context.next = 12;
            return ctx.project.exportSchema(_lowcodeTypes.IPublicEnumTransformStage.Save);
          case 12:
            originalSchema = _context.sent;
          case 13:
            _context.next = 15;
            return fixSchema(originalSchema);
          case 15:
            schema = _context.sent;
            console.log("got schema: ", schema);
            setState(function (prev) {
              return (0, _extends2["default"])({}, prev, {
                schema: schema,
                originalSchema: originalSchema
              });
            });

            // 出码...
            _context.next = 20;
            return (0, _standaloneLoader.generateCode)({
              solution: "gantLegacy",
              schema: schema,
              flattenResult: true,
              builderOptions: {
                // mode: 'fully',
                rootPaths: ["packages", "icost"],
                pagePaths: [],
                configPaths: []
              }
            });
          case 20:
            result = _context.sent;
            console.log("generated: ", result);
            setState(function (prev) {
              return (0, _extends2["default"])({}, prev, {
                loading: false,
                result: result
              });
            });
            _context.next = 29;
            break;
          case 25:
            _context.prev = 25;
            _context.t0 = _context["catch"](0);
            console.error("failed to run code generator: ", _context.t0);
            setState(function (prev) {
              return (0, _extends2["default"])({}, prev, {
                hasError: true,
                error: _context.t0 instanceof Error ? _context.t0 : new Error("" + ((_context.t0 === null || _context.t0 === void 0 ? void 0 : _context.t0.message) || _context.t0))
              });
            });
          case 29:
          case "end":
            return _context.stop();
        }
      }, _callee, null, [[0, 25]]);
    }));
    return function handleClick() {
      return _ref2.apply(this, arguments);
    };
  }();
  var _useRequest = (0, _ahooks.useRequest)(/*#__PURE__*/(0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee2() {
      var codeGen, content;
      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            _context2.prev = 0;
            codeGen = codeGenResultRef.current;
            if (codeGen) {
              _context2.next = 4;
              break;
            }
            return _context2.abrupt("return");
          case 4:
            _context2.next = 6;
            return codeGen.codeZip();
          case 6:
            content = _context2.sent;
            _fileSaver["default"].saveAs(content, "gant-lowcode-generated-sources.zip");
            _context2.next = 14;
            break;
          case 10:
            _context2.prev = 10;
            _context2.t0 = _context2["catch"](0);
            console.log("failed to download sources: ", _context2.t0);
            _message2["default"].error("下载失败！");
          case 14:
          case "end":
            return _context2.stop();
        }
      }, _callee2, null, [[0, 10]]);
    })), {
      manual: true
    }),
    run = _useRequest.run,
    downloading = _useRequest.loading;
  var handleDownload = /*#__PURE__*/function () {
    var _ref4 = (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee3(e) {
      return _regenerator["default"].wrap(function _callee3$(_context3) {
        while (1) switch (_context3.prev = _context3.next) {
          case 0:
            e.preventDefault();
            e.stopPropagation();
            run();
          case 3:
          case "end":
            return _context3.stop();
        }
      }, _callee3);
    }));
    return function handleDownload(_x) {
      return _ref4.apply(this, arguments);
    };
  }();
  var _useRequest2 = (0, _ahooks.useRequest)(/*#__PURE__*/(0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee4() {
      var codeGen, blob, setCodeUpload;
      return _regenerator["default"].wrap(function _callee4$(_context4) {
        while (1) switch (_context4.prev = _context4.next) {
          case 0:
            codeGen = codeGenResultRef.current;
            if (codeGen) {
              _context4.next = 3;
              break;
            }
            return _context4.abrupt("return");
          case 3:
            _context4.prev = 3;
            _context4.next = 6;
            return codeGen.codeZip();
          case 6:
            blob = _context4.sent;
            setCodeUpload = ctx.config.get("setCodeUpload");
            if (!setCodeUpload) {
              _context4.next = 11;
              break;
            }
            _context4.next = 11;
            return setCodeUpload({
              zipFile: blob
            });
          case 11:
            _context4.next = 17;
            break;
          case 13:
            _context4.prev = 13;
            _context4.t0 = _context4["catch"](3);
            console.log("failed to git push: ", _context4.t0);
            _message2["default"].error("上传失败！");
          case 17:
          case "end":
            return _context4.stop();
        }
      }, _callee4, null, [[3, 13]]);
    })), {
      manual: true
    }),
    handleUpload = _useRequest2.run,
    uploading = _useRequest2.loading;
  var drawerChildren = null;
  if (state.hasError) {
    var _state$error;
    drawerChildren = /*#__PURE__*/React.createElement(_alert["default"], {
      type: "error",
      message: "\u51FA\u9519\u4E86",
      description: (_state$error = state.error) === null || _state$error === void 0 ? void 0 : _state$error.message
    });
  }
  if (state.loading) {
    drawerChildren = /*#__PURE__*/React.createElement(_spin["default"], {
      className: "code-gen-plugin-loading",
      spinning: true,
      tip: "\u6B63\u5728\u51FA\u7801..."
    });
  }
  drawerChildren = /*#__PURE__*/React.createElement(_index.CodeGenResult, {
    ref: codeGenResultRef,
    result: state.result,
    schema: state.schema,
    originalSchema: state.originalSchema
  });
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(_button["default"], {
    type: "text",
    onClick: handleClick
  }, /*#__PURE__*/React.createElement(_icons.CodeOutlined, null)), /*#__PURE__*/React.createElement(_drawer["default"], {
    open: state.open,
    title: "\u51FA\u7801\u7ED3\u679C",
    width: "95vw",
    rootClassName: "code-gen-drawer",
    extra: /*#__PURE__*/React.createElement(_space["default"], null, /*#__PURE__*/React.createElement(_button["default"], {
      type: "link",
      onClick: handleUpload,
      loading: uploading
    }, "\u4E0A\u4F20git"), /*#__PURE__*/React.createElement(_button["default"], {
      type: "link",
      onClick: handleDownload,
      loading: downloading
    }, "\u4E0B\u8F7D\u6E90\u4EE3\u7801")),
    onClose: function onClose() {
      setState(function (prev) {
        return (0, _extends2["default"])({}, prev, {
          open: false
        });
      });
    }
  }, drawerChildren));
}
function fixSchema(_x2) {
  return _fixSchema.apply(this, arguments);
}
function _fixSchema() {
  _fixSchema = (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee5(schema) {
    return _regenerator["default"].wrap(function _callee5$(_context5) {
      while (1) switch (_context5.prev = _context5.next) {
        case 0:
          return _context5.abrupt("return", deepClone((0, _extends2["default"])({}, schema, {
            componentsMap: schema.componentsMap.filter(function (c) {
              return c["package"];
            }) // 去掉没有 package 的组件
            .map(function (c) {
              // 修正版本号（对于没有有效版本号的组件，默认使用 latest）
              if (!isValidVersion(c.version)) {
                console.warn('[WARN] got invalid version "%o" for component "%s", use "latest" as fallback', c.version, c);
                return (0, _extends2["default"])({}, c, {
                  version: "latest"
                });
              }

              // 修正 gantd-lowcode-materials 的版本，最小为1.1.0
              if (c["package"] === 'gantd-lowcode-materials' && (0, _compare["default"])((0, _coerce["default"])(c.version) || '', '1.1.0') <= 0) {
                return (0, _extends2["default"])({}, c, {
                  version: 'latest'
                });
              }
              return c;
            })
          })));
        case 1:
        case "end":
          return _context5.stop();
      }
    }, _callee5);
  }));
  return _fixSchema.apply(this, arguments);
}
function deepClone(x) {
  try {
    return JSON.parse(JSON.stringify(x));
  } catch (e) {
    throw new Error("failed to clone schema -- " + e);
  }
}
function isValidVersion(version) {
  if (!version) {
    return false;
  }

  // 对于一些明显非法的版本号过滤下
  if (version === "{{version}}" || version === "null" || version === "undefined") {
    return false;
  }

  // 对于 latest/beta/rc 这样的 tag 版本号要支持下
  if (/^[a-z][a-z0-9]+([a-z0-9-]+)?$/i.test(version)) {
    return true;
  }

  // 最后支持下所有 semver 能识别的版本
  return (0, _coerce["default"])(version) !== null;
}