"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.CodeGenResult = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _extends3 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _empty = _interopRequireDefault(require("antd/lib/empty"));
var _message2 = _interopRequireDefault(require("antd/lib/message"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _react = _interopRequireWildcard(require("react"));
var _fileSaver = _interopRequireDefault(require("file-saver"));
var _jszip = _interopRequireDefault(require("jszip"));
var _index = require("../sources-view/index");
require("./index.less");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
// import { CodeGenPreview } from "../code-gen-preview/index";

var CodeGenResult = exports.CodeGenResult = /*#__PURE__*/(0, _react.forwardRef)(function CodeGenResult(_ref, ref) {
  var result = _ref.result,
    schema = _ref.schema;
  var _useState = (0, _react.useState)({
      expandedKeys: ["sources", "preview"]
    }),
    paneState = _useState[0],
    setPaneState = _useState[1];
  var _useState2 = (0, _react.useState)(null),
    gravityCode = _useState2[0],
    setGravityCode = _useState2[1];
  var _useState3 = (0, _react.useState)(0),
    refresh = _useState3[0],
    setRefresh = _useState3[1];
  (0, _react.useEffect)(function () {
    console.log("--result, schema", result, schema);
    setGravityCode(convertCodeGenResult(result, schema));
  }, [result]);
  var codeZip = /*#__PURE__*/function () {
    var _ref2 = (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee() {
      var zip;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            zip = new _jszip["default"]();
            Object.values((gravityCode === null || gravityCode === void 0 ? void 0 : gravityCode.modules) || {}).forEach(function (file) {
              zip.file(file.fpath.replace(/^\/+/, ""), file.code);
            });
            _context.next = 4;
            return zip.generateAsync({
              type: "blob"
            });
          case 4:
            return _context.abrupt("return", _context.sent);
          case 5:
          case "end":
            return _context.stop();
        }
      }, _callee);
    }));
    return function codeZip() {
      return _ref2.apply(this, arguments);
    };
  }();
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      codeZip: codeZip
    };
  });
  if (!result) {
    return null;
  }
  var handleDownloadSources = /*#__PURE__*/function () {
    var _ref3 = (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee2(e) {
      var content;
      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            _context2.prev = 0;
            e.preventDefault();
            e.stopPropagation();
            _context2.next = 5;
            return codeZip();
          case 5:
            content = _context2.sent;
            _fileSaver["default"].saveAs(content, "gant-lowcode-generated-sources.zip");
            _context2.next = 13;
            break;
          case 9:
            _context2.prev = 9;
            _context2.t0 = _context2["catch"](0);
            console.log("failed to download sources: ", _context2.t0);
            _message2["default"].error("下载失败！");
          case 13:
          case "end":
            return _context2.stop();
        }
      }, _callee2, null, [[0, 9]]);
    }));
    return function handleDownloadSources(_x) {
      return _ref3.apply(this, arguments);
    };
  }();
  console.log("--gravityCode", gravityCode);

  // const items: TabsProps["items"] = [
  //   {
  //     key: "sources",
  //     label: (
  //       <span>
  //         出码生成的源代码{" "}
  //         <a href="javascript:void(0)" onClick={handleDownloadSources}>
  //           导出/下载 zip 包
  //         </a>
  //       </span>
  //     ),
  //     children: gravityCode != null && (
  //       <SourcesView code={gravityCode} onCodeChange={setGravityCode} />
  //     ),
  //   },
  //   {
  //     key: "preview",
  //     label: (
  //       <span>
  //         在线预览{" "}
  //         <a
  //           href="#refresh"
  //           onClick={(e) => {
  //             e.preventDefault();
  //             e.stopPropagation();
  //             setRefresh(Date.now());
  //           }}
  //         >
  //           刷新
  //         </a>
  //       </span>
  //     ),
  //     children: (
  //       <div
  //         className="code-gen-result-gravity-demo"
  //         style={{ height: "100%" }}
  //       >
  //         <CodeGenPreview
  //           code={gravityCode}
  //           height={"100%"}
  //           refresh={refresh}
  //         />
  //       </div>
  //     ),
  //   },
  // ];

  // return <Tabs className="code-gen-tabs" items={items} />;

  if (!gravityCode) return /*#__PURE__*/_react["default"].createElement(_empty["default"], null);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "code-gen-source-view"
  }, /*#__PURE__*/_react["default"].createElement(_index.SourcesView, {
    code: gravityCode,
    onCodeChange: setGravityCode
  }));
});
function convertCodeGenResult(result, schema) {
  var schemaFiles = {
    "/.project-schema.json": {
      fpath: "/.project-schema.json",
      code: JSON.stringify(schema, null, 2) + "\n"
    }
  };
  if (!result || !Array.isArray(result) || !result.length) {
    return {
      type: "demo",
      modules: schemaFiles
    };
  }
  var code = {
    type: "demo",
    modules: result.reduce(function (acc, file) {
      var _extends2;
      return (0, _extends3["default"])({}, acc, (_extends2 = {}, _extends2["/" + file.pathName] = {
        fpath: "/" + file.pathName,
        code: file.content,
        entry: undefined,
        packagejson: ["package.json"].includes(file.pathName) ? 1 : undefined
      }, _extends2));
    }, {})
  };
  var foundEntry = false;

  // 设置入口文件
  ["index.js", "index.ts", "index.tsx", "app.js", "app.ts", "app.tsx"].forEach(function (fileName) {
    if (!foundEntry) {
      var filePath = "/src/" + fileName;
      if (code.modules[filePath]) {
        foundEntry = true;
        if (fileName === "index.js") {
          code.modules[filePath].entry = 1;
        } else {
          code.modules["/src/index.js"] = {
            fpath: "/src/index.js",
            entry: 1,
            code: "import \"./" + fileName.replace(/\.\w+$/, "") + "\""
          };
        }
      }
    }
  });
  if (!foundEntry) {
    console.warn("Failed to find entry file for demo.");
  }

  // 补充 schema 文件
  // Object.assign(code.modules, schemaFiles);

  return code;
}