"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.SourcesView = SourcesView;
var _splitter = _interopRequireDefault(require("antd/lib/splitter"));
var _extends3 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _react = _interopRequireWildcard(require("react"));
var _lowcodePluginBaseMonacoEditor = _interopRequireDefault(require("@gant-lowcode/lowcode-plugin-base-monaco-editor"));
require("@gant-lowcode/lowcode-plugin-base-monaco-editor/lib/style.js");
var _index = require("../file-tree/index");
require("./index.less");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var DEBOUNCE_UPDATE_INTERVAL_IN_MS = 500;
function SourcesView(_ref) {
  var _state$currentFile, _state$currentFile2, _state$currentFile3, _state$currentFile4, _state$currentFile5;
  var code = _ref.code,
    onCodeChange = _ref.onCodeChange;
  var editorContainerRef = (0, _react.useRef)(null);
  var _useState = (0, _react.useState)(function () {
      var allFiles = Object.values(code.modules);
      var currentFile = [allFiles.find(function (x) {
        return /pages.+(js|ts)x?$/.test(x.fpath);
      }), allFiles.find(function (m) {
        return m.entry;
      })].filter(Boolean)[0];
      return {
        currentFile: currentFile,
        selectedKeys: [currentFile === null || currentFile === void 0 ? void 0 : currentFile.fpath]
      };
    }),
    state = _useState[0],
    setState = _useState[1];
  var _useState2 = (0, _react.useState)(0),
    height = _useState2[0],
    setHeight = _useState2[1];
  (0, _react.useEffect)(function () {
    var observer = new ResizeObserver(function () {
      if (editorContainerRef.current) {
        var _editorContainerRef$c = editorContainerRef.current.getBoundingClientRect(),
          _height = _editorContainerRef$c.height;
        setHeight(_height - 2);
      }
    });
    if (editorContainerRef.current) {
      observer.observe(editorContainerRef.current);
    }
    return function () {
      if (editorContainerRef.current) {
        observer.unobserve(editorContainerRef.current);
      }
    };
  }, []);
  var ref = (0, _react.useRef)({
    debounceTimer: null
  });
  var onSelect = function onSelect(key) {
    setState(function (prev) {
      if (ref.current.debounceTimer) {
        ref.current.debounceTimer = null;
      }
      return (0, _extends3["default"])({}, prev, {
        currentFile: code.modules[key] || prev.currentFile
      });
    });
  };
  return /*#__PURE__*/_react["default"].createElement(_splitter["default"], {
    className: "sources-panes"
  }, /*#__PURE__*/_react["default"].createElement(_splitter["default"].Panel, {
    defaultSize: 300,
    min: 300,
    max: "70%",
    className: "file-tree-pane"
  }, /*#__PURE__*/_react["default"].createElement(_index.FileTree, {
    modules: code.modules,
    onSelect: onSelect,
    selectedKeys: (_state$currentFile = state.currentFile) !== null && _state$currentFile !== void 0 && _state$currentFile.fpath ? [(_state$currentFile2 = state.currentFile) === null || _state$currentFile2 === void 0 ? void 0 : _state$currentFile2.fpath] : undefined
  })), /*#__PURE__*/_react["default"].createElement(_splitter["default"].Panel, {
    className: "source-code-pane"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    ref: editorContainerRef,
    style: {
      height: "100%"
    }
  }, /*#__PURE__*/_react["default"].createElement(_lowcodePluginBaseMonacoEditor["default"], {
    height: height,
    language: getFileLanguage((_state$currentFile3 = state.currentFile) === null || _state$currentFile3 === void 0 ? void 0 : _state$currentFile3.fpath),
    saveViewState: true,
    defaultValue: (_state$currentFile4 = state.currentFile) === null || _state$currentFile4 === void 0 ? void 0 : _state$currentFile4.code,
    path: (_state$currentFile5 = state.currentFile) === null || _state$currentFile5 === void 0 ? void 0 : _state$currentFile5.fpath,
    onChange: function onChange(value) {
      console.debug("[monaco editor] onChange: %o (currentFile: %o)", {
        value: value
      }, state.currentFile);
      var currentFile = state.currentFile;
      if (currentFile) {
        if (ref.current.debounceTimer) {
          clearTimeout(ref.current.debounceTimer);
        }
        ref.current.debounceTimer = setTimeout(function () {
          var _extends2;
          ref.current.debounceTimer = null;
          onCodeChange((0, _extends3["default"])({}, code, {
            modules: (0, _extends3["default"])({}, code.modules, (_extends2 = {}, _extends2[currentFile.fpath] = (0, _extends3["default"])({}, currentFile, {
              code: value || ""
            }), _extends2))
          }));
        }, DEBOUNCE_UPDATE_INTERVAL_IN_MS);
      }
    }
  }))));
}
function getFileLanguage(file) {
  switch ((file || "").split(".").pop()) {
    case "ts":
    case "tsx":
      return "typescript";
    case "js":
    case "jsx":
      return "javascript";
    case "css":
      return "css";
    case "scss":
      return "scss";
    case "less":
      return "less";
    case "json":
      return "json";
    case "md":
      return "markdown";
    default:
      return "text";
  }
}