"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var CodeGenerator = _interopRequireWildcard(require("@gant-lowcode/code-generator/standalone-loader"));
var _codeGenAction = require("./components/code-gen-action");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var plugin = function plugin(ctx, options) {
  return {
    // 插件对外暴露的数据和方法
    exports: function exports() {
      return {
        generateCode: CodeGenerator.generateCode
      };
    },
    // 插件的初始化函数，在引擎初始化之后会立刻调用
    init: function init() {
      return (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee() {
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;
              if (!(options !== null && options !== void 0 && options.disableCodeGenActionBtn)) {
                ctx.skeleton.add({
                  type: "Custom",
                  name: "code-generator",
                  area: "topArea",
                  props: {
                    align: "right",
                    width: 100
                  },
                  content: _codeGenAction.CodeGenActionBtn,
                  contentProps: {
                    ctx: ctx
                  }
                });
              }

              // 提前初始化下，这样后面用的时候更快
              CodeGenerator.init();
              _context.next = 9;
              break;
            case 5:
              _context.prev = 5;
              _context.t0 = _context["catch"](0);
              console.error("[plugin-code-geneator] failed to init: ", _context.t0);
              throw _context.t0;
            case 9:
            case "end":
              return _context.stop();
          }
        }, _callee, null, [[0, 5]]);
      }))();
    },
    destroy: function destroy() {}
  };
};
plugin.pluginName = "codeGenerator";
plugin.meta = {
  dependencies: [],
  preferenceDeclaration: {
    title: "codeGenerator 的参数定义",
    properties: [{
      key: "disableCodeGenActionBtn",
      type: "boolean",
      description: "是否要禁用出码的动作按钮"
    }]
  }
};
var _default = exports["default"] = plugin;